// Stack.cpp

#include "Stack.h"
#include <cassert>
#include <iostream>

Stack::Stack(int m) : _max(m), _count(0) {
    _a = new char[_max];
    assert(_a != 0);
}

Stack::~Stack() {
    delete [] _a;
}

char Stack::top() const {
    assert (_count > 0);
    return _a[_count-1];
}

bool Stack::is_empty() const {
    return (_count == 0); //bool(_count == 0);
}

bool Stack::is_full() const {
    return (_count == _max); //bool(_count == _max);
}

void Stack::push(const char x) {
    assert(_count < _max);
    _a[_count++] = x;
}

char Stack::pop() {
    assert(_count > 0);
    return _a[--_count];
}

void Stack::print() {
    //char tmp;
    std::cout << "\n_count = " << _count << std::endl;
    int cnt = _count;
    Stack temp(_count);
    while(!((*this).is_empty())) { //copy the stack to temp
        temp.push((*this).pop());
        std::cout << temp.top();
    }
    while(!(temp.is_empty())) { //copy temp back to the stack
        (*this).push(temp.pop());
        //std::cout << temp.top();
    }
//    *this = temp;
//    std::cout << "\nAfter the assignment, *this = temp, (*this).top() = "
//              << (*this).top() << std::endl;
//    //(*this).push(temp.pop());
}
